unit u_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ExtDlgs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure ShowText(a_file : string);
  public

  end;

var
  Form1: TForm1;

implementation

uses
  ImagingTypes, Imaging, ImagingClasses, ImagingComponents,
  ImagingCanvases, ImagingBinary, ImagingUtility;

var
  FBitmap : TImagingBitmap;
  FImage : TMultiImage;
  Fext : string;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
    ShowText(OpenPictureDialog1.FileName);
end;

procedure TForm1.ShowText(a_file : string);
var
  ts:TTextStyle;
//можно и через основной битмап работать
//эффект одинаков. Т.е. TMultiImage результирующий файл отображает в цвете,
//а вот Image1 грит - серое....
  FBitmap1 : TImagingBitmap;
  FIm : TMultiImage;
  bmp : TMemoryStream;
begin
  Fext := GetFileExt(a_file);
  FIm := TMultiImage.Create;
  FIm.LoadFromFile(a_file);
  //настраиваем параметры вывода текста
  FBitmap1 := TImagingBitmap.Create;
  FBitmap1.AssignFromImageData(FIm.ImageDataPointer^);//копируем в битмап изображение
  ts := FBitmap1.Canvas.TextStyle;
  ts.SingleLine :=false;
  ts.Alignment :=taLeftJustify;
  ts.Layout :=tlTop;

  FBitmap1.Canvas.Font.Size := 80;
  FBitmap1.Canvas.Font.Quality := fqCleartypeNatural;
  FBitmap1.Canvas.Font.Color := clGreen;
  FBitmap1.Canvas.TextRect(Rect(0,0, FBitmap1.Width, FBitmap1.Height),0, 0,'text', ts);
  FBitmap1.AssignToImage(FIm);//копируем из битмапа что нарисовали
  //это не верный подход для вампира...
  bmp := TMemoryStream.Create;
  Fim.SaveMultiToStream(Fext, bmp);
  bmp.Position := 0;
  FImage.LoadMultiFromStream(bmp);
  Image1.Picture.Graphic.Assign(FImage);
  FreeAndNil(bmp);
  FreeAndNil(Fim);
  FreeAndNil(FBitmap1);
//в других вариациях (без потока) изображается серым...
//т.е. Image1 "не хочет" цвет показать :)
//Почему? Да кто его знает. Может карты ложатся не правильно.
//Т.е. необходимо создать слой и совместить с основным.
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FBitmap := TImagingBitmap.Create;
  FImage := TMultiImage.Create;
  Image1.Picture.Bitmap := FBitmap;
end;

end.

